/* 
 * Berkeley Lab Checkpoint/Restart (BLCR) for Linux is Copyright (c)
 * 2003, The Regents of the University of California, through Lawrence
 * Berkeley National Laboratory (subject to receipt of any required
 * approvals from the U.S. Dept. of Energy).  All rights reserved.
 *
 * Portions may be copyrighted by others, as may be noted in specific
 * copyright notices within specific files.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: cr_arch.h,v 1.4 2004/12/10 22:38:26 phargrov Exp $
 */

#ifndef _CR_ARCH_H
#define _CR_ARCH_H	1

// Catch-all file for misc. arch-specific bits

#ifdef PIC
  #define CRI_SYSCALL_PRE \
	"\tpushl %%ebx\n"				\
	"\tmovl %2,%%ebx\n"
  #define CRI_SYSCALL_POST \
	"\tpopl %%ebx\n"
  #define CRI_SYSCALL_ARG1 "r"
#else
  #define CRI_SYSCALL_PRE
  #define CRI_SYSCALL_POST
  #define CRI_SYSCALL_ARG1 "b"
#endif


#define cri_syscall_cleanup(res,errno_p) \
    __asm__ volatile ("" ::: "memory", "cc", "cx", "dx");\
    if ((unsigned long)res >= (unsigned long)(-4096)) {	\
	if (errno_p != NULL) { *errno_p = -res; }	\
	res = -1;					\
    }

// XXX: does syscall5 work w/ PIC?
#define cri_syscall5(nr,arg1,arg2,arg3,arg4,arg5,errno_p)\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	CRI_SYSCALL_PRE					\
	"\tint $0x80\n"					\
	CRI_SYSCALL_POST				\
        : "=a" (_res)					\
        : "0" (nr),					\
	  CRI_SYSCALL_ARG1 ((long)(arg1)),		\
	  "c" ((long)(arg2)),				\
	  "d" ((long)(arg3)),				\
	  "S" ((long)(arg4)),				\
	  "D" ((long)(arg5)));				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall4(nr,arg1,arg2,arg3,arg4,errno_p)	\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	CRI_SYSCALL_PRE					\
	"\tint $0x80\n"					\
	CRI_SYSCALL_POST				\
        : "=a" (_res)					\
        : "0" (nr),					\
	  CRI_SYSCALL_ARG1 ((long)(arg1)),		\
	  "c" ((long)(arg2)),				\
	  "d" ((long)(arg3)),				\
	  "S" ((long)(arg4)));				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall3(nr,arg1,arg2,arg3,errno_p)		\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	CRI_SYSCALL_PRE					\
	"\tint $0x80\n"					\
	CRI_SYSCALL_POST				\
        : "=a" (_res)					\
        : "0" (nr),					\
	  CRI_SYSCALL_ARG1 ((long)(arg1)),		\
	  "c" ((long)(arg2)),				\
	  "d" ((long)(arg3)));				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall2(nr,arg1,arg2,errno_p)		\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	CRI_SYSCALL_PRE					\
	"\tint $0x80\n"					\
	CRI_SYSCALL_POST				\
        : "=a" (_res)					\
        : "0" (nr),					\
	  CRI_SYSCALL_ARG1 ((long)(arg1)),		\
	  "c" ((long)(arg2)));				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall1(nr,arg1,errno_p)			\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	CRI_SYSCALL_PRE					\
	"\tint $0x80\n"					\
	CRI_SYSCALL_POST				\
        : "=a" (_res)					\
        : "0" (nr),					\
	  CRI_SYSCALL_ARG1 ((long)(arg1)));		\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall0(nr,errno_p)			\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tint $0x80\n"					\
        : "=a" (_res)					\
        : "0" (nr));					\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })

#endif
