/* 
 * Berkeley Lab Checkpoint/Restart (BLCR) for Linux is Copyright (c)
 * 2003, The Regents of the University of California, through Lawrence
 * Berkeley National Laboratory (subject to receipt of any required
 * approvals from the U.S. Dept. of Energy).  All rights reserved.
 *
 * Portions may be copyrighted by others, as may be noted in specific
 * copyright notices within specific files.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: cr_arch.h,v 1.3 2005/02/17 01:00:23 phargrov Exp $
 */

#ifndef _CR_ARCH_H
#define _CR_ARCH_H	1

// Catch-all file for misc. arch-specific bits


#define cri_syscall_cleanup(res,errno_p) \
    __asm__ volatile ("" ::: "cc", "r11", "rcx", "memory");\
    if ((unsigned long)res >= (unsigned long)(-4096)) {	\
	if (errno_p != NULL) { *errno_p = -res; }	\
	res = -1;					\
    }

#define cri_syscall6(nr,arg1,arg2,arg3,arg4,arg5,arg6,errno_p)\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tmovq %5,%%r10\n"				\
	"\tmovq %6,%%r8\n"				\
	"\tmovq %7,%%r9\n"				\
	"\tsyscall\n"					\
        : "=a" (_res)					\
        : "0" (nr),					\
	  "D" ((long)(arg1)),				\
	  "S" ((long)(arg2)),				\
	  "d" ((long)(arg3)),				\
	  "g" ((long)(arg4)),				\
	  "g" ((long)(arg5)),				\
	  "g" ((long)(arg6))				\
	: "r8", "r9", "r10");				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall5(nr,arg1,arg2,arg3,arg4,arg5,errno_p)\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tmovq %5,%%r10\n"				\
	"\tmovq %6,%%r8\n"				\
	"\tsyscall\n"					\
        : "=a" (_res)					\
        : "0" (nr),					\
	  "D" ((long)(arg1)),				\
	  "S" ((long)(arg2)),				\
	  "d" ((long)(arg3)),				\
	  "g" ((long)(arg4)),				\
	  "g" ((long)(arg5))				\
	: "r8", "r10");					\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall4(nr,arg1,arg2,arg3,arg4,errno_p)	\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tmovq %5,%%r10\n"				\
	"\tsyscall\n"					\
        : "=a" (_res)					\
        : "0" (nr),					\
	  "D" ((long)(arg1)),				\
	  "S" ((long)(arg2)),				\
	  "d" ((long)(arg3)),				\
	  "g" ((long)(arg4))				\
	: "r10");					\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall3(nr,arg1,arg2,arg3,errno_p)		\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tsyscall\n"					\
        : "=a" (_res)					\
        : "0" (nr),					\
	  "D" ((long)(arg1)),				\
	  "S" ((long)(arg2)),				\
	  "d" ((long)(arg3)));				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall2(nr,arg1,arg2,errno_p)		\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tsyscall\n"					\
        : "=a" (_res)					\
        : "0" (nr),					\
	  "D" ((long)(arg1)),				\
	  "S" ((long)(arg2)));				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall1(nr,arg1,errno_p)			\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tsyscall\n"					\
        : "=a" (_res)					\
        : "0" (nr),					\
	  "D" ((long)(arg1)));				\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })
#define cri_syscall0(nr,errno_p)			\
    ({							\
      long _res;					\
      __asm__ volatile (				\
	"\tsyscall\n"					\
        : "=a" (_res)					\
        : "0" (nr));					\
      cri_syscall_cleanup(_res, errno_p);		\
      _res;						\
    })

/* signal return trampoline, from glibc-2.3.2 */
#include <asm-x86_64/unistd.h>
#ifndef __NR_rt_sigreturn
  #error "no value for __NR_rt_sigreturn"
#endif
#define CRI_SA_RESTORER3(name, syscall)   \
  __asm__ (                               \
	".align 16\n"                     \
	#name ":\n"                       \
	"    movq $" #syscall ", %rax\n"  \
	"    syscall\n"                   \
  );                                      \
  static void cri_sa_restorer(void) __attribute__((alias(#name)));
#define CRI_SA_RESTORER2(name, syscall) CRI_SA_RESTORER3(name, syscall)
#define CRI_SA_RESTORER CRI_SA_RESTORER2(__restore_rt, __NR_rt_sigreturn)

#ifndef SA_RESTORER
  #define SA_RESTORER 0x04000000
#endif

#endif
